close all
clear all

load('BallBearing90EDM6or_15.8degree_100depth_500N_12.5Hz.mat');

%sens_Acc_x = 31.6;         % m/s^2/V 
%sens_Acc_y = 1;
%sens_Acc_z = 1;
sens_Eddy_x = 50; % micro.Meter/V ; note that 250mM DC should be added
sens_Eddy_y = 50; %
sens_Mic = 11.2e-3;
sens_load = 508*4.448 ;% N/V
sens = 100; % used for calibration

TitleFont = 12;
LabelFont = 10;
gcaFont = 10;

%% Convert voltage signals to accelerations

    Speed_Measured = fc(data(:,1),Fs,ceil(2/speed)); % to get at least 2 rev per second %% calculate the Speed in Hz
    Ex = data(:,2)*sens_Eddy_x + 250;
    Ey = data(:,3)*sens_Eddy_y + 250;
    Ax = data(:,4)*-sens_Acc_x;
    Ay = data(:,5)*-sens_Acc_y;
    Az = data(:,6)*sens_Acc_z;
    Load = data(:,7)*sens_load;
    SPL = data(:,8);
    SPL1 =SPL/20e-6;
    SPL1 = 20*log10(SPL1);

%% plot times series data of acceleration in the x dir. 
figure
plot(time, Ax)

%% Cutting up Time Series Dat into Entry and Exit Events align the max. value

t=.025;
t=.02813;
i=1;
Hz=12.49;
offset = 0.012/(Hz/5);
shiftExit = 553/(Hz/5);
shiftEntry = 899/(Hz/5);
%impulses = cell(floor(10/.0375));

while (t+.032) < 9.5
    
    temp = Ax([ceil((t-offset)*Fs):1:ceil((t+offset)*Fs)]);
    [X, I] = max(temp);
    t=t-(ceil(length(temp)/2 -I)/Fs);
    %t=t-((308 -I)/Fs);
    EntryImpulses{i} = Ax([ceil((t-offset)*Fs):1:ceil((t+offset)*Fs)]);
    t=t+shiftExit/Fs;
    temp = Ax([ceil((t-offset)*Fs):1:ceil((t+offset)*Fs)]);
    [X, I] = max(temp);
    t=t-(ceil(length(temp)/2 -I)/Fs);
    %t=t-((308 -I)/Fs);
    ExitImpulses{i} = Ax([ceil((t-offset)*Fs):1:ceil((t+offset)*Fs)]);
    i= i+1;
    t=t+shiftEntry/Fs;
   
end

%% Plot Slices 
EntryImpulsesMat = zeros(length(EntryImpulses{1}),length(EntryImpulses));
ExitImpulsesMat = zeros(length(ExitImpulses{1}),length(ExitImpulses));
figure
hold on
for i=1:length(EntryImpulses)
    plot([1:1:length(EntryImpulses{i})]*1000/Fs, EntryImpulses{i}-mean(EntryImpulses{i}), 'b')
    if(length(EntryImpulses{1})== length(EntryImpulses{i}))
        EntryImpulsesMat(:,i) = EntryImpulses{i}-mean(EntryImpulses{i});
    elseif(length(EntryImpulses{1})> length(EntryImpulses{i}))
        TempEntry = EntryImpulses{i}-mean(EntryImpulses{i});
        EntryImpulsesMat([1:1:length(EntryImpulses{i})],i) = TempEntry([1:1:length(EntryImpulses{i})]);
      
    else
        TempEntry = EntryImpulses{i}-mean(EntryImpulses{i});
        EntryImpulsesMat([1:1:length(EntryImpulses{1})],i) = TempEntry([1:1:length(EntryImpulses{1})]);
        
    end
    
    if(length(ExitImpulses{1})== length(ExitImpulses{i}))
        ExitImpulsesMat(:,i) = ExitImpulses{i}-mean(ExitImpulses{i});
    elseif(length(ExitImpulses{1})> length(ExitImpulses{i}))
        
        TempExit = ExitImpulses{i}-mean(ExitImpulses{i});
        ExitImpulsesMat([1:1:length(ExitImpulses{i})],i) = TempExit([1:1:length(ExitImpulses{i})]);
    else
        
        TempExit = ExitImpulses{i}-mean(ExitImpulses{i});
        ExitImpulsesMat([1:1:length(ExitImpulses{1})],i) = TempExit([1:1:length(ExitImpulses{1})]);
    end
end
hold off
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
title('Entry Time Slices','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');

figure
hold on
for i=1:length(ExitImpulses)
    plot([1:1:length(ExitImpulses{i})]*1000/Fs, ExitImpulses{i}-mean(ExitImpulses{i}), 'b')
   
end
hold off
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
title('Exit Time Slices','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');

%% Calculate the Mean and Standard Deviation of the slices

MeanEntry = mean(EntryImpulsesMat,2);
STDEntry = std(EntryImpulsesMat')';
MeanExit = mean(ExitImpulsesMat,2);
STDExit = std(ExitImpulsesMat')';

figure
plot([1:1:length(MeanEntry)]*1000/Fs,MeanEntry, '-b', [1:1:length(MeanEntry)]*1000/Fs,MeanEntry-STDEntry, '--r', [1:1:length(MeanEntry)]*1000/Fs,MeanEntry+STDEntry, '--r' )
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
l = legend('Mean', 'SD');
set(l,'Interpreter','Latex');
title('Entry Ensemble Average','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');

figure
plot([1:1:length(MeanExit)]*1000/Fs,MeanExit, '-b', [1:1:length(MeanExit)]*1000/Fs,MeanExit-STDExit, '--r', [1:1:length(MeanExit)]*1000/Fs,MeanExit+STDExit, '--r')
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
l = legend('Mean', 'SD');
set(l,'Interpreter','Latex');
title('Exit Ensemble Average','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');
%%
TitleFont = 16;
LabelFont = 14;
gcaFont = 14;
%% STFT Entry
x= MeanEntry;
% define analysis parameters
xlen = length(x);                   % length of the signal
wlen = 90;                        % window length (recomended to be power of 2)
hop = wlen/16;                       % hop size (recomended to be power of 2)
nfft = 4096;
alpha =2.5;
% number of fft points (recomended to be power of 2)
win = gausswin(wlen,alpha);
% perform STFT
[S, f, t] = stft(x, wlen, hop, nfft, Fs, alpha, win);

% define the coherent amplification of the window
%K = sum(hamming(wlen, 'periodic'))/wlen;
K= sum(win)/wlen;
% take the amplitude of fft(x) and scale it, so not to be a
% function of the length of the window and its coherent amplification
S = abs(S)/(max(max(abs(S))))/2;%;/wlen/K;

% correction of the DC & Nyquist component
if rem(nfft, 2)                     % odd nfft excludes Nyquist point
    S(2:end, :) = S(2:end, :).*2;
else                                % even nfft includes Nyquist point
    S(2:end-1, :) = S(2:end-1, :).*2;
end

% plot the spectrogram
h=figure
contour(t*1000, f, S)
colormap jet;
%shading interp
axis tight
box on
view(0, 90)
ylim([0 2000]);
y = ylabel('Frequency (Hz)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
%c=colorbar;
%caxis([0,1]);
%c.Label.String = {'\makebox[4cm][c]{Power/Frequecy}' , '\makebox[4cm][c]{(dB/Hz)}'};
%.TickLabelInterpreter = 'latex';
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
set(h,'Position', [100 100 250 250])
xlim([2 8])
%% STFT Exit

x= MeanExit;
% define analysis parameters
xlen = length(x);                   % length of the signal
wlen = 90;                        % window length (recomended to be power of 2)
hop = wlen/16;                       % hop size (recomended to be power of 2)
nfft = 4096;
alpha =2.5;
% number of fft points (recomended to be power of 2)
win = gausswin(wlen,alpha);
% perform STFT
[S, f, t] = stft(x, wlen, hop, nfft, Fs, alpha, win);

% define the coherent amplification of the window
%K = sum(hamming(wlen, 'periodic'))/wlen;
K= sum(win)/wlen;
% take the amplitude of fft(x) and scale it, so not to be a
% function of the length of the window and its coherent amplification
S = abs(S)/(max(max(abs(S))))/2;%/wlen/K;

% correction of the DC & Nyquist component
if rem(nfft, 2)                     % odd nfft excludes Nyquist point
    S(2:end, :) = S(2:end, :).*2;
else                                % even nfft includes Nyquist point
    S(2:end-1, :) = S(2:end-1, :).*2;
end

% plot the spectrogram
h=figure
contour(t*1000, f, S)
colormap jet;
%shading interp
axis tight
box on
view(0, 90)
ylim([0 2000]);
y = ylabel('Frequency (Hz)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
%c=colorbar;
%caxis([0,1]);
%c.Label.String = {'\makebox[4cm][c]{Power/Frequecy}' , '\makebox[4cm][c]{(dB/Hz)}'};
%c.TickLabelInterpreter = 'latex';
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
set(h,'Position', [100 100 250 250])
xlim([2 8])