close all
clear all

%load('Bearing0EDM2or_0degree_110depth_5000N_5Hz.mat');
load('BallBearing90EDM6or_15.8degree_100depth_500N_5Hz.mat');
%load('Bearing30EDM2or_1000degree_110depth_51100N_5Hz.mat');
%sens_Acc_x = 31.6;         % m/s^2/V 
%sens_Acc_y = 1;
%sens_Acc_z = 1;
sens_Eddy_x = 50; % micro.Meter/V ; note that 250mM DC should be added
sens_Eddy_y = 50; %
sens_Mic = 11.2e-3;
sens_load = 508*4.448 ;% N/V
sens = 100; % used for calibration

TitleFont = 14;
LabelFont = 12;
gcaFont = 12;

%% Convert voltage signals to accelerations

    Speed_Measured = fc(data(:,1),Fs,ceil(2/speed)); % to get at least 2 rev per second %% calculate the Speed in Hz
    Ex = data(:,2)*sens_Eddy_x + 250;
    Ey = data(:,3)*sens_Eddy_y + 250;
    Ax = data(:,4)*-sens_Acc_x;
    Ay = data(:,5)*-sens_Acc_y;
    Az = data(:,6)*sens_Acc_z;
    Load = data(:,7)*sens_load;
    SPL = data(:,8);
    SPL1 =SPL/20e-6;
    SPL1 = 20*log10(SPL1);

%% Power spectrum

nfft = Fs/1;
F    = 0:Fs/nfft:Fs/2;
win  = hanning(nfft,'periodic');
% win  = flattopwin(nfft);

    Px   = pwelch(Ax,win,[],nfft,Fs);
    Py   = pwelch(Ay,win,[],nfft,Fs);
    Pz   = pwelch(Az,win,[],nfft,Fs);
    pEx   = pwelch(Ex,win,[],nfft,Fs);
    pEy   = pwelch(Ey,win,[],nfft,Fs);
    pSPL   = pwelch(SPL,win,[],nfft,Fs);


%% Envelope spectrum
% close all

f1      = 1e3;
f2      = 12e3;
[be,ae] = butter(3,[f1 f2]/(Fs/2));
Ax_Env      = pwelch(abs(hilbert(filter(be,ae,Ax))),win,[],nfft,Fs);
Ay_Env    = pwelch(abs(hilbert(filter(be,ae,Ay))),win,[],nfft,Fs);
Az_Env      = pwelch(abs(hilbert(filter(be,ae,Az))),win,[],nfft,Fs);

%% Signal Processing
f1      = 20;
[be,ae] = butter(3,f1/(Fs/2),'high');
Ex_filt = filtfilt(be,ae,Ex);

tmin = 4.685; 
tmax = 4.72;
%figure
%subplot(3,1,1);
% plot(Ex,Ey);
% xlabel('Ex'); ylabel('Ey'); title('Ex-Ey');
% grid on; 
% ylim([-10 600]);xlim([-10 600]);
f1      = 1;
f2      = 485;

[be,ae] = butter(3,[f1 f2]/(Fs/1),'bandpass');
Ax_filt = filtfilt(be,ae,Ax);
S1 = find(Wenglor([ceil((tmin+.02)*Fs):1:ceil((tmax+.02)*Fs)])<1);
II = find(Wenglor([ceil(tmin*Fs):1:ceil(tmax*Fs)])<1);
w = 1/(((S1(1)-II(1))/Fs+.02)*13);
w= (Speed_Measured(4)/2)*(1-(((.0555-.0375)/2)/(.0375+.009)))
ref = ceil((ceil(II(1)+II(length(II))))/2);
%Zoom_Ax = Ax([ceil(tmin*Fs):1:ceil(tmax*Fs)]);
%Zoom_Ax_filt = Ax_filt([ceil(tmin*Fs):1:ceil(tmax*Fs)]);
%Zoom_Ex = Ex_filt([ceil(tmin*Fs):1:ceil(tmax*Fs)]);
%Zoom_Ex = Zoom_Ex([-ceil(.005*Fs)+ref:1:ceil(.025*Fs)+ref]);
%Zoom_Ax = Zoom_Ax([-ceil(.005*Fs)+ref:1:ceil(.025*Fs)+ref]);
%Zoom_Ax_filt = Zoom_Ax_filt([-ceil(.005*Fs)+ref:1:ceil(.025*Fs)+ref]);
%position = -187-(.01*360);
%position = [position:((1/Fs)*w*360):(position+((length(Zoom_Ax)-1)/Fs*w*360))];
%plot([1:1:10*Fs]/Fs,Ex_filt,'b');%, position,Zoom_Ex,'r');
f1      = 150;
f2      = 4500;

[be,ae] = butter(3,[f1 f2]/(Fs/1),'bandpass');

Ax = filtfilt(be,ae,Ax);% + filtfilt(be1,ae1,Ax)+ filtfilt(be2,ae2,Ax);


figure
plot(time, Ax)

t=.025;
t=.054;
i=1;
%impulses = cell(floor(10/.0375));

while (t+.032) < 9.5
    
    temp = Ax([ceil((t-.012)*Fs):1:ceil((t+.012)*Fs)]);
    [X, I] = max(temp);
    t=t-(ceil(length(temp)/2 -I)/Fs);
    %t=t-((308 -I)/Fs);
    EntryImpulses{i} = Ax([ceil((t-.012)*Fs):1:ceil((t+.012)*Fs)]);
    t=t+553/Fs;
    temp = Ax([ceil((t-.012)*Fs):1:ceil((t+.012)*Fs)]);
    [X, I] = max(temp);
    t=t-(ceil(length(temp)/2 -I)/Fs);
    %t=t-((308 -I)/Fs);
    ExitImpulses{i} = Ax([ceil((t-.012)*Fs):1:ceil((t+.012)*Fs)]);
    i= i+1;
    t=t+899/Fs;
   
end
EntryImpulsesMat = zeros(length(EntryImpulses{1}),length(EntryImpulses));
ExitImpulsesMat = zeros(length(EntryImpulses{1}),length(EntryImpulses));
figure
hold on
for i=1:length(EntryImpulses)
    plot([1:1:length(EntryImpulses{i})], EntryImpulses{i}-mean(EntryImpulses{i}), 'b')
    EntryImpulsesMat(:,i) = EntryImpulses{i}-mean(EntryImpulses{i});
    ExitImpulsesMat(:,i) = ExitImpulses{i}-mean(ExitImpulses{i});
end
hold off

%% Calculate the Mean and Standard Deviation of the slices

MeanEntry = mean(EntryImpulsesMat,2);
STDEntry = std(EntryImpulsesMat')';
MeanExit = mean(ExitImpulsesMat,2);
STDExit = std(ExitImpulsesMat')';

h=figure
plot([1:1:length(MeanEntry)]*1000/Fs,MeanEntry, '-b', [1:1:length(MeanEntry)]*1000/Fs,MeanEntry-STDEntry, '--r', [1:1:length(MeanEntry)]*1000/Fs,MeanEntry+STDEntry, '--r' )
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
l = legend('Mean', 'SD');
set(l,'Interpreter','Latex');
title('Entry Ensemble Average','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');
set(h,'Position', [100 100 400 350])
xlim([5, 20]);
h=figure
plot([1:1:length(MeanExit)]*1000/Fs,MeanExit, '-b', [1:1:length(MeanExit)]*1000/Fs,MeanExit-STDExit, '--r', [1:1:length(MeanExit)]*1000/Fs,MeanExit+STDExit, '--r')
y = ylabel('Accelerometer (m/s$^{2}$)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
l = legend('Mean', 'SD');
set(l,'Interpreter','Latex');
title('Exit Ensemble Average','FontSize',TitleFont,'FontWeight','bold','Interpreter', 'Latex');
set(h,'Position', [100 100 400 350])
xlim([5, 20]);
%%
TitleFont = 16;
LabelFont = 14;
gcaFont = 14;

%% STFT Entry
x= MeanEntry;
% define analysis parameters
xlen = length(x);                   % length of the signal
wlen = 128;                        % window length (recomended to be power of 2)
hop = wlen/4;                       % hop size (recomended to be power of 2)
nfft = 4096;
alpha =2.5;
% number of fft points (recomended to be power of 2)
win = gausswin(wlen,alpha);
% perform STFT
[S, f, t] = stft(x, wlen, hop, nfft, Fs, alpha, win);

% define the coherent amplification of the window
%K = sum(hamming(wlen, 'periodic'))/wlen;
K= sum(win)/wlen;
% take the amplitude of fft(x) and scale it, so not to be a
% function of the length of the window and its coherent amplification
S = abs(S)/(max(max(abs(S))))/2;%;/wlen/K;

% correction of the DC & Nyquist component
if rem(nfft, 2)                     % odd nfft excludes Nyquist point
    S(2:end, :) = S(2:end, :).*2;
else                                % even nfft includes Nyquist point
    S(2:end-1, :) = S(2:end-1, :).*2;
end

% plot the spectrogram
h=figure
contour(t*1000, f, S)
colormap jet;
%shading interp
axis tight
box on
view(0, 90)
ylim([0 2000]);
y = ylabel('Frequency (Hz)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
%c=colorbar;
%caxis([0,1]);
%c.Label.String = {'\makebox[4cm][c]{Power/Frequecy}' , '\makebox[4cm][c]{(dB/Hz)}'};
%.TickLabelInterpreter = 'latex';
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
set(h,'Position', [100 100 250 250])
xlim([5 20])
%% STFT Exit

x= MeanExit;
% define analysis parameters
xlen = length(x);                   % length of the signal
wlen = 128;                        % window length (recomended to be power of 2)
hop = wlen/4;                       % hop size (recomended to be power of 2)
nfft = 4096;
alpha =2.5;
% number of fft points (recomended to be power of 2)
win = gausswin(wlen,alpha);
% perform STFT
[S, f, t] = stft(x, wlen, hop, nfft, Fs, alpha, win);

% define the coherent amplification of the window
%K = sum(hamming(wlen, 'periodic'))/wlen;
K= sum(win)/wlen;
% take the amplitude of fft(x) and scale it, so not to be a
% function of the length of the window and its coherent amplification
S = abs(S)/(max(max(abs(S))))/2;%/wlen/K;

% correction of the DC & Nyquist component
if rem(nfft, 2)                     % odd nfft excludes Nyquist point
    S(2:end, :) = S(2:end, :).*2;
else                                % even nfft includes Nyquist point
    S(2:end-1, :) = S(2:end-1, :).*2;
end

% plot the spectrogram
h=figure
contour(t*1000, f, S)
colormap jet;
%shading interp
axis tight
box on
view(0, 90)
ylim([0 2000]);
y = ylabel('Frequency (Hz)','FontSize',LabelFont,'FontWeight','bold');
set(y,'Interpreter','Latex')
x = xlabel('Time (ms)','FontSize',LabelFont,'FontWeight','bold');
set(x,'Interpreter','Latex')
grid on;
%c=colorbar;
%caxis([0,1]);
%c.Label.String = {'\makebox[4cm][c]{Power/Frequecy}' , '\makebox[4cm][c]{(dB/Hz)}'};
%.TickLabelInterpreter = 'latex';
set(gca,'FontSize',gcaFont)
set(gca,'TickLabelInterpreter', 'latex');
set(h,'Position', [100 100 250 250])
xlim([5 20])